<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJPSOAP_IntCodeAttr ArrayType
 * @subpackage Arrays
 */
class ArrayOfJPSOAP_IntCodeAttr extends AbstractStructArrayBase
{
    /**
     * The SupplementCategory
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JPSOAP_IntCodeAttr[]
     */
    public $SupplementCategory;
    /**
     * Constructor method for ArrayOfJPSOAP_IntCodeAttr
     * @uses ArrayOfJPSOAP_IntCodeAttr::setSupplementCategory()
     * @param \StructType\JPSOAP_IntCodeAttr[] $supplementCategory
     */
    public function __construct(array $supplementCategory = array())
    {
        $this
            ->setSupplementCategory($supplementCategory);
    }
    /**
     * Get SupplementCategory value
     * @return \StructType\JPSOAP_IntCodeAttr[]|null
     */
    public function getSupplementCategory()
    {
        return $this->SupplementCategory;
    }
    /**
     * This method is responsible for validating the values passed to the setSupplementCategory method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSupplementCategory method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSupplementCategoryForArrayConstraintsFromSetSupplementCategory(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJPSOAP_IntCodeAttrSupplementCategoryItem) {
            // validation for constraint: itemType
            if (!$arrayOfJPSOAP_IntCodeAttrSupplementCategoryItem instanceof \StructType\JPSOAP_IntCodeAttr) {
                $invalidValues[] = is_object($arrayOfJPSOAP_IntCodeAttrSupplementCategoryItem) ? get_class($arrayOfJPSOAP_IntCodeAttrSupplementCategoryItem) : sprintf('%s(%s)', gettype($arrayOfJPSOAP_IntCodeAttrSupplementCategoryItem), var_export($arrayOfJPSOAP_IntCodeAttrSupplementCategoryItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SupplementCategory property can only contain items of type \StructType\JPSOAP_IntCodeAttr, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SupplementCategory value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_IntCodeAttr[] $supplementCategory
     * @return \ArrayType\ArrayOfJPSOAP_IntCodeAttr
     */
    public function setSupplementCategory(array $supplementCategory = array())
    {
        // validation for constraint: array
        if ('' !== ($supplementCategoryArrayErrorMessage = self::validateSupplementCategoryForArrayConstraintsFromSetSupplementCategory($supplementCategory))) {
            throw new \InvalidArgumentException($supplementCategoryArrayErrorMessage, __LINE__);
        }
        $this->SupplementCategory = $supplementCategory;
        return $this;
    }
    /**
     * Add item to SupplementCategory value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_IntCodeAttr $item
     * @return \ArrayType\ArrayOfJPSOAP_IntCodeAttr
     */
    public function addToSupplementCategory(\StructType\JPSOAP_IntCodeAttr $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JPSOAP_IntCodeAttr) {
            throw new \InvalidArgumentException(sprintf('The SupplementCategory property can only contain items of type \StructType\JPSOAP_IntCodeAttr, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SupplementCategory[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JPSOAP_IntCodeAttr|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JPSOAP_IntCodeAttr|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JPSOAP_IntCodeAttr|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JPSOAP_IntCodeAttr|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JPSOAP_IntCodeAttr|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SupplementCategory
     */
    public function getAttributeName()
    {
        return 'SupplementCategory';
    }
}
